unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, GLScene, GLObjects, GLCoordinates,
  GLCollision, AsyncTimer, GLCrossPlatform, BaseClasses, GLWin32Viewer,
  GLGeomObjects;

type
  TForm1 = class(TForm)
    GLSceneViewer1: TGLSceneViewer;
    GLScene1: TGLScene;
    AsyncTimer1: TAsyncTimer;
    CollisionManager1: TCollisionManager;
    GLDummyCube1: TGLDummyCube;
    GLCube1: TGLCube;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLCube2: TGLCube;
    GLCube3: TGLCube;
    GLCube4: TGLCube;
    GLCube5: TGLCube;
    GLCylinder1: TGLCylinder;
    GLPortIzq: TGLCube;
    GLCube6: TGLCube;
    procedure FormCreate(Sender: TObject);
    procedure AsyncTimer1Timer(Sender: TObject);
    procedure CollisionManager1Collision(Sender: TObject; object1,
      object2: TGLBaseSceneObject);
  private
    { Private declarations }
    xx,yy,zz,
    RR,dx,dy    : single;
    t           : integer;
    ang         : single;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  randomize;
  xx := GLCylinder1.Position.X;
  yy := GLCylinder1.Position.Y;
  zz := GLCylinder1.Position.Z;
  RR := GLCylinder1.TopRadius;
  t  := 0;

  ang := random(90)-45;
  dx := -0.1*cos(ang*Pi/180);
  dy :=  0.1*sin(ang*Pi/180);
end;

procedure TForm1.AsyncTimer1Timer(Sender: TObject);
begin
  xx := xx + dx;
  yy := yy + dy;

  GLCylinder1.Position.SetPoint(xx,yy,zz);
  CollisionManager1.CheckCollisions;

end;

procedure TForm1.CollisionManager1Collision(Sender: TObject;
  object1,
  object2: TGLBaseSceneObject);
var
  nom1,nom2 : string;
begin
  nom1 := object1.Name;
  nom2 := object2.Name;

  if ((nom1=GLCylinder1.Name) and (nom2=GLCube2.Name)) OR
     ((nom2=GLCylinder1.Name) and (nom1=GLCube2.Name))
  then begin
    dx := -dx;
  end;

  if ((nom1=GLCylinder1.Name) and (nom2=GLCube3.Name)) OR
     ((nom2=GLCylinder1.Name) and (nom1=GLCube3.Name))
  then begin
    dx := -dx;
  end;

  if ((nom1=GLCylinder1.Name) and (nom2=GLCube4.Name)) OR
     ((nom2=GLCylinder1.Name) and (nom1=GLCube4.Name))
  then begin
    dy := -dy;
  end;

  if ((nom1=GLCylinder1.Name) and (nom2=GLCube5.Name)) OR
     ((nom2=GLCylinder1.Name) and (nom1=GLCube5.Name))
  then begin
    dy := -dy;
  end;

  // Gol
  if ((nom1=GLCylinder1.Name) and (nom2=GLPortIzq.Name)) OR
     ((nom2=GLCylinder1.Name) and (nom1=GLPortIzq.Name))
  then begin
    AsyncTimer1.Enabled := false;
  end;

end;


end.
